// <auto-generated />

#pragma warning disable

using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using Link = System.ComponentModel.DescriptionAttribute;

[ExcludeFromCodeCoverage]
#if PolyPublic
public
#endif
static partial class EnumPolyfill
{
    /// <summary>
    /// Retrieves an array of the values of the constants in a specified enumeration type.
    /// </summary>
    /// <returns>An array that contains the values of the constants in TEnum.</returns>
    [Link("https://learn.microsoft.com/en-us/dotnet/api/system.enum.getvalues")]
    public static TEnum[] GetValues<TEnum>()
        where TEnum : struct, Enum
    {
#if NETCOREAPPX || NETFRAMEWORK || NETSTANDARD
       var values = Enum.GetValues(typeof(TEnum));
       var result = new TEnum[values.Length];
       Array.Copy(values, result, values.Length);
       return result;
#else
       return Enum.GetValues<TEnum>();
#endif
    }
    /// <summary>
    /// Retrieves an array of the names of the constants in a specified enumeration type.
    /// </summary>
    /// <returns>A string array of the names of the constants in TEnum.</returns>
    [Link("https://learn.microsoft.com/en-us/dotnet/api/system.enum.getnames")]
    public static string[] GetNames<TEnum>()
        where TEnum : struct, Enum
    {
#if NETCOREAPPX || NETFRAMEWORK || NETSTANDARD
       return Enum.GetNames(typeof(TEnum));
#else
       return Enum.GetNames<TEnum>();
#endif
    }
}
