// <auto-generated />

#pragma warning disable

#if !NET7_0_OR_GREATER

using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using Link = System.ComponentModel.DescriptionAttribute;

static partial class Polyfill
{
    /// <summary>
    /// Gets the key corresponding to the specified index.
    /// </summary>
    /// <param name="index">The zero-based index of the key within the entire <see cref="SortedList{TKey, TValue}"/>.</param>
    /// <returns>The key corresponding to the specified index.</returns>
    /// <exception cref="ArgumentOutOfRangeException">The specified index is out of range.</exception>
    [Link("https://learn.microsoft.com/en-us/dotnet/api/system.collections.generic.sortedlist-2.getkeyatindex?view=net-8.0")]
    public static TKey GetKeyAtIndex<TKey, TValue>(
        this SortedList<TKey, TValue> target, int index) =>
        target.Keys[index];

    /// <summary>
    /// Gets the value corresponding to the specified index.
    /// </summary>
    /// <param name="index">The zero-based index of the value within the entire <see cref="SortedList{TKey, TValue}"/>.</param>
    /// <returns>The value corresponding to the specified index.</returns>
    [Link("https://learn.microsoft.com/en-us/dotnet/api/system.collections.generic.sortedlist-2.getvalueatindex?view=net-8.0")]
    public static TValue GetValueAtIndex<TKey, TValue>(
        this SortedList<TKey, TValue> target, int index) =>
        target.Values[index];
}
#endif